Bug 1288930 - Review Request: abi-tracker - Tool to visualize ABI changes timeline of a C/C++ library
Review Request: abi-tracker - Tool to visualize ABI changes timeline of a C/C...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jonathan Underwood
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-12-06 22:48 EST by Richard Shaw
Modified: 2015-12-31 18:29 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-17 02:29:24 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jonathan.underwood: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Richard Shaw 2015-12-06 22:48:32 EST
Spec URL: http://hobbes1069.fedorapeople.org//abi-tracker.spec
SRPM URL: http://hobbes1069.fedorapeople.org//abi-tracker-1.4-1.fc22.src.rpm

Description:
A tool to visualize ABI changes timeline of a C/C++ software library.

The tool requires input profile of the library in JSON format. It can be created
manually or automatically generated by the ABI Monitor:
https://github.com/lvc/abi-monitor
Comment 1 Richard Shaw 2015-12-06 22:50:57 EST
Scratch build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=12096591
Comment 2 Jonathan Underwood 2015-12-07 06:41:02 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

Summary
-------
- Couple of typos to fix in summary/descrption
- Man page needed
- Copyright header needs clarification in Basic.pm, and possibly the
  CSS files

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL", "Unknown or generated". 10 files have unknown license.
     Detailed output of licensecheck in /home/jgu/Fedora/1288930-abi-
     tracker/licensecheck.txt

The Basic.pm module has a copyright header which doesn't actually
specify the license. It's sort of clear the intent is for it to be
GPL/LGPL, but it would be good to ask upstream to clarify that in the
copyright header. Not a blocker, though. Similarly, no copyright
header is present in the CSS files, so it'd be nice to have one there
too, but not mandatory.

[-]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Perl:
[x]: Package contains the mandatory BuildRequires and Requires:.

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: abi-tracker-1.4-1.fc24.noarch.rpm
          abi-tracker-1.4-1.fc24.src.rpm
abi-tracker.noarch: W: spelling-error Summary(en_US) timeline -> time line, time-line, timeliness
abi-tracker.noarch: W: spelling-error %description -l en_US timeline -> time line, time-line, timeliness

---> These should be fixed (trivial)

abi-tracker.noarch: W: no-manual-page-for-binary abi-tracker

---> Please file an upstream request for a man page to be written.

abi-tracker.src: W: spelling-error Summary(en_US) timeline -> time line, time-line, timeliness
abi-tracker.src: W: spelling-error %description -l en_US timeline -> time line, time-line, timeliness

---> As above.

2 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
abi-tracker.noarch: W: no-manual-page-for-binary abi-tracker
1 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
abi-tracker (rpmlib, GLIBC filtered):
    /usr/bin/perl
    abi-compliance-checker
    abi-dumper
    perl(:MODULE_COMPAT_5.22.0)
    perl(Cwd)
    perl(Data::Dumper)
    perl(Fcntl)
    perl(File::Basename)
    perl(File::Path)
    perl(File::Temp)
    perl(Getopt::Long)
    perl(strict)
    pkgdiff
    rfcdiff
    vtable-dumper



Provides
--------
abi-tracker:
    abi-tracker
Comment 3 Jonathan Underwood 2015-12-07 06:42:00 EST
None of the issues I've raised are blockers, so will set as APPROVED, but please do tackle them (particularly the man page).
Comment 4 Richard Shaw 2015-12-07 08:56:55 EST
I'll take a look, I've used txt2man and help2man in the past but that's all it would be, a copy of abi-tracker --help...
Comment 5 Gwyn Ciesla 2015-12-07 09:50:55 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/abi-tracker
Comment 6 Jonathan Underwood 2015-12-07 10:44:30 EST
Great. It'd be useful if a man page also contained the info on the profile format and examples found in the README. But, I think it's fine to leave that work for upstream if you don't have the time available - I wasn't implying you should write a man page :).
Comment 7 Fedora Update System 2015-12-07 19:20:06 EST
abi-tracker-1.4-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-e1b1d00074
Comment 8 Fedora Update System 2015-12-07 19:20:06 EST
abi-tracker-1.4-2.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-eec35dd836
Comment 9 Fedora Update System 2015-12-07 19:20:13 EST
abi-tracker-1.4-2.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-d1760cd434
Comment 10 Fedora Update System 2015-12-08 02:20:49 EST
abi-tracker-1.4-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'yum --enablerepo=epel-testing update abi-tracker'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-eec35dd836
Comment 11 Fedora Update System 2015-12-08 17:57:57 EST
abi-tracker-1.4-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update abi-tracker'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-e1b1d00074
Comment 12 Fedora Update System 2015-12-08 18:51:09 EST
abi-tracker-1.4-2.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update abi-tracker'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-d1760cd434
Comment 13 Fedora Update System 2015-12-09 09:59:23 EST
abi-compliance-checker-1.99.13-1.el7 abi-tracker-1.4-2.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-eec35dd836
Comment 14 Upstream Release Monitoring 2015-12-10 02:49:52 EST
pbrobinson's scratch build of abi-compliance-checker?#e6b47813727768f39af6fe931511c6e1f8954526 for epel7-archbootstrap and git://pkgs.fedoraproject.org/abi-compliance-checker?#e6b47813727768f39af6fe931511c6e1f8954526 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12134711
Comment 15 Fedora Update System 2015-12-10 06:22:09 EST
abi-compliance-checker-1.99.13-1.el7, abi-dumper-0.99.12-1.el7, abi-tracker-1.4-2.el7, pkgdiff-1.7.0-1.el7, rfcdiff-1.41-7.el7, vtable-dumper-1.1-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'yum --enablerepo=epel-testing update rfcdiff abi-dumper pkgdiff vtable-dumper abi-compliance-checker abi-tracker'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-eec35dd836
Comment 16 Fedora Update System 2015-12-14 09:36:43 EST
abi-compliance-checker-1.99.13-1.el7 abi-dumper-0.99.13-1.el7 abi-tracker-1.4-2.el7 pkgdiff-1.7.1-1.el7 rfcdiff-1.41-7.el7 vtable-dumper-1.1-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-eec35dd836
Comment 17 Fedora Update System 2015-12-15 02:20:34 EST
abi-compliance-checker-1.99.13-1.el7, abi-dumper-0.99.13-1.el7, abi-tracker-1.4-2.el7, pkgdiff-1.7.1-1.el7, rfcdiff-1.41-7.el7, vtable-dumper-1.1-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'yum --enablerepo=epel-testing update pkgdiff abi-dumper rfcdiff vtable-dumper abi-compliance-checker abi-tracker'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2015-eec35dd836
Comment 18 Fedora Update System 2015-12-17 02:29:21 EST
abi-tracker-1.4-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.
Comment 19 Fedora Update System 2015-12-17 03:52:32 EST
abi-tracker-1.4-2.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.
Comment 20 Fedora Update System 2015-12-31 18:29:06 EST
abi-compliance-checker-1.99.13-1.el7, abi-dumper-0.99.13-1.el7, abi-tracker-1.4-2.el7, pkgdiff-1.7.1-1.el7, rfcdiff-1.41-7.el7, vtable-dumper-1.1-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.